Index: Log.cpp
===================================================================
RCS file: /cvsroot/babyftpd/babyftpd/Log.cpp,v
retrieving revision 1.21
diff -u -p -b -r1.21 Log.cpp
--- Log.cpp	23 Jan 2005 17:56:47 -0000	1.21
+++ Log.cpp	10 Apr 2005 22:43:19 -0000
@@ -1,5 +1,5 @@
 ///////////////////////////////////////////////////////////////////
-//  $Id: Log.cpp,v 1.21 2005/01/23 17:56:47 klas Exp $
+//  $Id: Log.cpp,v 1.29 2005/03/27 23:50:18 jockelundin Exp $
 //
 //  Usage: Logging functions etc.
 //
@@ -7,13 +7,15 @@
 //    LICENSE for complete information.
 /////////////////////////////////////////////////////////////////////
 
-#define __LOG_CPP__
+#define LOG_CPP
 #include "Log.h"
 
+class Log *logging;
+
 Log::Log(void)
 {
-  sem_init(&this->to_log_lock, 0, 1); // 1 means it is not locked
-  sem_init(&this->data_ready, 0, 0); // and 0 means it is locked, flagged to 1 when there is data
+  sem_init(&this->to_log_lock, 0, 1);
+  sem_init(&this->data_ready, 0, 0);
 
   openlog("BabyFTPd", LOG_PID, LOG_FTP);
 }
@@ -40,20 +42,33 @@ void Log::log_this(int log_level, int lo
   this->to_log.push_back(temp_data);
   sem_post(&this->to_log_lock);
 
-  sem_post(&this->data_ready); // bump data_ready to tell main thread there is data
+  // bump data_ready to tell main thread there is data
+  sem_post(&this->data_ready);
 }
 
 
 void Log::log_main(void)
 {
   setuid(config->general.user);
+  setgid(config->general.group);
+
+  size_t time_string_len;
+
+  {
+    string temp;
+    time_string_len = util.time_string(temp, config->logger.time_format, 500);
+    time_string_len++;
+  }
+
   while(true)
   {
-    sem_wait(&this->data_ready); // if data_ready is zero we wait for it to increase
+    // if data_ready is zero we wait for it to increase
+    sem_wait(&this->data_ready);
 
     if(this->to_log.size() == 0)
     {
-      this->log_this(3, TYPE_DEBUG, "data->ready triggered without there being any data to log.");
+      this->log_this(3, TYPE_DEBUG,
+          "data->ready triggered without there being any data to log.");
       continue;
     }
 
@@ -90,6 +105,15 @@ void Log::log_main(void)
         break;
     }
 
+    if((temp_data.type == TYPE_AUTH && !config->logger.authlog.empty()) ||
+        (temp_data.type == TYPE_INFO && !config->logger.infolog.empty()) ||
+        (temp_data.type == TYPE_DEBUG && !config->logger.debuglog.empty()))
+    {
+      string timestr;
+      util.time_string(timestr, config->logger.time_format, time_string_len);
+      temp_data.message.insert(0, timestr);
+    }
+
     switch(temp_data.type)
     {
       case TYPE_XFER:
@@ -146,8 +170,8 @@ void Log::authlog(struct log_data data_t
   }
 }
 
-  void Log::infolog(struct log_data data_to_log)
-  {
+void Log::infolog(struct log_data data_to_log)
+{
   if(config->logger.infolog.empty())
     syslog(LOG_FTP | data_to_log.level, data_to_log.message.c_str());
   else
Index: Log.h
===================================================================
RCS file: /cvsroot/babyftpd/babyftpd/Log.h,v
retrieving revision 1.8
diff -u -p -b -r1.8 Log.h
--- Log.h	17 Jan 2005 22:21:44 -0000	1.8
+++ Log.h	10 Apr 2005 22:43:19 -0000
@@ -1,5 +1,5 @@
 /////////////////////////////////////////////////////////////////////
-//  $Id: Log.h,v 1.8 2005/01/17 22:21:44 klas Exp $
+//  $Id: Log.h,v 1.11 2005/03/28 16:57:13 klas Exp $
 //
 //  Usage: Logging defines, functions etc.
 //
@@ -7,14 +7,14 @@
 //    LICENSE for complete information.
 /////////////////////////////////////////////////////////////////////
 
-#ifndef __LOG_H__
-#define __LOG_H__
+#ifndef LOG_H
+#define LOG_H
 
-#ifdef __LOG_CPP__
+#ifdef LOG_CPP
 #include "generic.h"
 #include "Configuration.h"
 #include "Utilities.h"
-#endif // __LOG_CPP__
+#endif // LOG_CPP
 
 class Log
 {
@@ -34,6 +34,7 @@ class Log
     ~Log(void);
 };
 
+extern class Log *logging;
 
 struct log_data
 {
@@ -42,12 +43,9 @@ struct log_data
   string message;
 };
 
-extern class Log *logging;
-extern class Configuration *config;
-
-#define TYPE_XFER 1
-#define TYPE_AUTH 2
-#define TYPE_INFO 3
-#define TYPE_DEBUG 4
+const int TYPE_XFER = 1;
+const int TYPE_AUTH = 2;
+const int TYPE_INFO = 3;
+const int TYPE_DEBUG = 4;
 
-#endif // __LOG_H__
+#endif // LOG_H
Index: StringTokenizer.cpp
===================================================================
RCS file: /cvsroot/babyftpd/babyftpd/StringTokenizer.cpp,v
retrieving revision 1.9
diff -u -p -b -r1.9 StringTokenizer.cpp
--- StringTokenizer.cpp	16 Jan 2005 01:19:12 -0000	1.9
+++ StringTokenizer.cpp	10 Apr 2005 22:43:20 -0000
@@ -1,5 +1,5 @@
 /////////////////////////////////////////////////////////////////////
-// $Id: StringTokenizer.cpp,v 1.9 2005/01/16 01:19:12 klas Exp $
+// $Id: StringTokenizer.cpp,v 1.16 2005/04/02 09:41:46 klas Exp $
 //
 // Usage: Used to chop up a string in "tokens"
 //
@@ -7,106 +7,92 @@
 //    LICENSE for complete information.
 /////////////////////////////////////////////////////////////////////
 
-#define __STRINGTOKENIZER_CPP__
+#define STRINGTOKENIZER_CPP
 #include "StringTokenizer.h"
 
 /*
-This class is made to handel strings. The StringTokenizer chops a string up into tokens using delimeters defined in a string passed ass an argument to the constructor.
+This class is made to handel strings. The StringTokenizer chops a string 
+up into tokens using delimeters defined in a string passed ass an argument 
+to the constructor.
 
-The idea of writing this class comes from a similar class in java. but this is more functional and works in a better way.
+The idea of writing this class comes from a similar class in java. but this 
+is more functional and works in a better way.
 
 The construktor takes three arguments, two strings and one bool. 
 The first string is the string you want to make tokens of.
-The secound string is a string containing all the characters that are going to cut the string.
-The bool determins if the token chars should come with the tokens or not. If the bool is set to false, the chars used to chop up the string is taken away.
+The secound string is a string containing all the characters that are 
+going to cut the string.
+The bool determins if the token chars should come with the tokens or not.
+If the bool is set to false, the chars used to chop up the string is taken 
+away.
 */
 
 //Original constructor
-StringTokenizer::StringTokenizer(string str, string delim = " \t\n\r\f", bool returnDelims = false)
+StringTokenizer::StringTokenizer(string str, string delim = " \t\n\r\f",
+    bool returnDelims = false)
 {
-  currentPosition = 0;
-  newPosition = -1;
-  delimsChanged = false;
   text = str;
-  maxPosition = str.length();
+  currentPosition = text.begin();
   delimiters = delim;
   retDelims = returnDelims;
 }
 
 //Private function used to get the position of the token.
-int StringTokenizer::scanToken(int startPos) 
+string::iterator StringTokenizer::scanToken(string::iterator startPos) const
 {
-  int position = startPos;
-  while (position < maxPosition) {
-    char c = text[position];
-    if (isDelimiter(c))
+  while (startPos != text.end())
+  {
+    if (isDelimiter(*startPos))
+    {
+      if(retDelims)
+        startPos++;
       break;
-    position++; 
   }
-  if (retDelims && (startPos == position)) {
-    char c = text[position];
-    if (isDelimiter(c))
-      position++;
+    startPos++;
   }
-  return position;  
-}
-
-//Private function that checks if a chatacter is a belimiter.
-bool StringTokenizer::isDelimiter(char character)
-{
-  for(size_t i = 0; i < delimiters.length(); i++){
-    if ((character == delimiters[i]) && (delimiters.find_first_of(character) >= 0))
-      return true;    
-  }
-  return false;
+  return startPos;
 }
 
 //Private function that returns a position so that the delimiters is skipped.
-int StringTokenizer::skipDelimiters(int startPos) 
+string::iterator StringTokenizer::skipDelimiters(string::iterator startPos)
+  const
 {
-  if (delimiters.compare("") == 0)
-    logging->log_this(2, TYPE_INFO, "Error: NullPointerException.");
-
-  int position = startPos;
-  while (!retDelims && position < maxPosition) {
-    char c = text[position];
-    if (!isDelimiter(c) || (delimiters.find_first_of(c) < 0)){
-      return position;
-    }
-    position++;
+  while (!retDelims && startPos != text.end())
+  {
+    if (!isDelimiter(*startPos) || (delimiters.find(*startPos) == string::npos))
+      break;
+    startPos++;
   }
-  return position;
+  return startPos;
 }
 
-//Public function that checks if the string got ore tokens.
-bool StringTokenizer::hasMoreTokens()
+//Public function that checks if the string got more tokens.
+bool StringTokenizer::hasMoreTokens() const
 {
-  newPosition = skipDelimiters(currentPosition);
-  return (newPosition < maxPosition);
+  return((skipDelimiters(currentPosition) == text.end()) ? false : true);
 }
 
 //Public function that returns the next token.
 string StringTokenizer::nextToken()
 {
-  currentPosition = (newPosition >= 0 && !delimsChanged) ? newPosition : skipDelimiters(currentPosition);
-  delimsChanged = false;
-  newPosition = -1;
+  currentPosition = skipDelimiters(currentPosition);
 
-  if (currentPosition >= maxPosition)
+  if (currentPosition == text.end())
     logging->log_this(2, TYPE_INFO, "NoSuchElementException.");
 
-  int start = currentPosition;
+  string::iterator start = currentPosition;
   currentPosition = scanToken(currentPosition);
-  return text.substr(start, currentPosition-start);
+  return string(start, currentPosition);
 }
 
 //Public functoin that retutns the number of tokens the string is containing.
-int StringTokenizer::countTokens() {
+int StringTokenizer::countTokens() const
+{
   int count = 0;
-  int currpos = currentPosition;
-  while (currpos < maxPosition) {
+  string::iterator currpos = currentPosition;
+  while (currpos != text.end()) {
     currpos = skipDelimiters(currpos);
-    if (currpos >= maxPosition)
+    if (currpos == text.end())
       break;
     currpos = scanToken(currpos);
     count++; 
@@ -114,25 +100,9 @@ int StringTokenizer::countTokens() {
   return count;  
 }
 
-//Public function that returns the next token.
-string StringTokenizer::nextToken(string delim) 
-{
-  delimiters = delim;
-  delimsChanged = true;
-  return nextToken();  
-}
-
 //Public function that returns all the tokens after the last used.
 string StringTokenizer::restTokens(void)
 {
-  string str = "";
-  while(hasMoreTokens())
-    str += nextToken();
-
-  for(size_t i = 0; i < delimiters.length(); i++){
-    while(str.find_first_of(delimiters[i]) == 0){
-       str.erase(0, 1);
-    }
-  }  
-  return str;    
+  return(string(isDelimiter(*currentPosition) ?
+        currentPosition + 1 : currentPosition, text.end()));
 }
Index: StringTokenizer.h
===================================================================
RCS file: /cvsroot/babyftpd/babyftpd/StringTokenizer.h,v
retrieving revision 1.8
diff -u -p -b -r1.8 StringTokenizer.h
--- StringTokenizer.h	16 Jan 2005 01:19:12 -0000	1.8
+++ StringTokenizer.h	10 Apr 2005 22:43:20 -0000
@@ -1,5 +1,5 @@
 /////////////////////////////////////////////////////////////////////
-// $Id: StringTokenizer.h,v 1.8 2005/01/16 01:19:12 klas Exp $
+// $Id: StringTokenizer.h,v 1.12 2005/03/29 19:02:29 klas Exp $
 //
 // Usage: Used to chop up a string in "tokens"
 //
@@ -7,10 +7,10 @@
 //    LICENSE for complete information.
 /////////////////////////////////////////////////////////////////////
 
-#ifndef __STRINGTOKENIZER_H__
-#define __STRINGTOKENIZER_H__
+#ifndef STRINGTOKENIZER_H
+#define STRINGTOKENIZER_H
 
-#ifdef __STRINGTOKENIZER_CPP__
+#ifdef STRINGTOKENIZER_CPP
 #include "generic.h"
 #include "Log.h"
 #endif
@@ -19,24 +19,21 @@ class StringTokenizer
 {
   public:
     StringTokenizer(string, string, bool);
-    bool hasMoreTokens(void);
+    bool hasMoreTokens(void) const;
     string nextToken();
-    int countTokens(void);
-    string nextToken(string);
+    int countTokens(void) const;
     string restTokens(void);
 
   private:
-    int skipDelimiters(int);
-    int scanToken(int);
-    bool isDelimiter(char);
-
-    int currentPosition;
-    int newPosition;
-    int maxPosition;
+    string::iterator skipDelimiters(string::iterator) const;
+    string::iterator scanToken(string::iterator) const;
+    bool isDelimiter(char c) const
+    { return(delimiters.find(c) == string::npos ? false : true ); }
+
+    string::iterator currentPosition;
     string text;
     string delimiters;
     bool retDelims;
-    bool delimsChanged;    
 };
 
 #endif
Index: User.cpp
===================================================================
RCS file: /cvsroot/babyftpd/babyftpd/User.cpp,v
retrieving revision 1.70
diff -u -p -b -r1.70 User.cpp
--- User.cpp	23 Jan 2005 01:34:53 -0000	1.70
+++ User.cpp	10 Apr 2005 22:43:20 -0000
@@ -1,5 +1,5 @@
 /////////////////////////////////////////////////////////////////////
-// $Id: User.cpp,v 1.70 2005/01/23 01:34:53 klas Exp $
+// $Id: User.cpp,v 1.92 2005/04/10 21:57:55 klas Exp $
 //
 // Usage: Holds information about connected users.
 //
@@ -7,173 +7,58 @@
 //    LICENSE for complete information.
 /////////////////////////////////////////////////////////////////////
 
-#define __USER_CPP__
-#define __NETINCLS__
+#define USER_CPP
+#define NETINCLS
 #include "User.h"
 
-Data::Data(User *user, int file_id, string file_name, int trans_type){
-  sem_wait(&user->user_lock);
-  sem_init(&data_lock, 0, 1);
-
-  Data::file_id = file_id;
-  Data::file_name = file_name;
-  Data::data_addr = user->data_addr;
-  Data::settings = user->settings;
-  Data::user = user;
-  if(trans_type == 1)
-    this->settings.set(RETR_TRANS);
-
-  this->settings.set(DATA_OPEN);
-  Data::rest_pos = 0;
-#ifdef USE_TLS
-  this->settings.reset(TLS_INITED);
-  this->settings.reset(TLS_ENABLED);
-#endif // USE_TLS
-
-  if(user->settings.test(PASSIVE))
-  {
-    socklen_t len = sizeof(this->data_addr);
-    if((this->data_id = accept(user->data_id, reinterpret_cast<struct sockaddr*>(&this->data_addr), &len)) < 0)
-      this->settings.reset(DATA_OPEN);
-    close(user->data_id);
-  }
-  else // ACTIVE
-  {
-    if(this->data_id)
-      close(Data::data_id);
-
-    this->data_id = socket(AF_INET, SOCK_STREAM, IPPROTO_TCP);
-    int on = 1;
-    setsockopt(this->data_id, SOL_SOCKET, SO_REUSEADDR,
-        (static_cast<void*>(&on)), sizeof(on));
-    struct sockaddr_in my_addr;
-    my_addr.sin_port = htons(20);
-    my_addr.sin_addr.s_addr = htonl(INADDR_ANY);
-    // active connections should originate at port 20, for that we need root.
-    uid_t old_uid = geteuid();
-    seteuid(0);
-    int ret = bind(this->data_id, reinterpret_cast<struct sockaddr*>
-        (&my_addr), sizeof(my_addr));
-    seteuid(old_uid);
-    if(ret != 0)
-      logging->log_this(3, LOG_INFO,
-          "Failed to bind to data port 20, falling back to arbitrary port.");
-
-    if(connect(this->data_id, reinterpret_cast<struct sockaddr*>
-          (&this->data_addr), sizeof(this->data_addr)) < 0)
-      this->settings.reset(DATA_OPEN);
-  }
-  // if the data connection comes from another host than the
-  // ctrl connection we drop it.. unless the user is tls protected.
-  if(this->data_addr.sin_addr.s_addr != user->ctrl_addr.sin_addr.s_addr)
-  {
-#ifdef USE_TLS
-    if(!user->settings.test(TLS_ENABLED))
-    {
-#endif // USE_TLS
-      close(this->data_id);
-      this->settings.reset(DATA_OPEN);
-    }
-#ifdef USE_TLS
-  }
-  if(this->settings.test(TLS_PROT_D)) // setting tls stuff up, handshake later
-  { 
-    comm.init_tls(this->data_session);
-    this->settings.set(TLS_INITED);
-    gnutls_transport_set_ptr(this->data_session, reinterpret_cast<gnutls_transport_ptr>(this->data_id));
-  }
-#endif //USE_TLS
-  sem_post(&user->user_lock);
-}
-
-bool Data::isOpen() const
+User::User(int socket_id, struct sockaddr_in &addr) : Connection()
 {
-  return(this->settings.test(DATA_OPEN));
-}
-
-Data::~Data(){
-  if(data_id)
-    close(data_id);
-  if(file_id)
-    close(file_id);
-
-  sem_destroy(&data_lock);
-
-#ifdef USE_TLS
-  // TLS cleanup here.
-  if(this->settings.test(TLS_INITED))
-  {
-    gnutls_db_remove_session(this->data_session);
-    gnutls_deinit(this->data_session);
-  }
-#endif
-          
-  if(!pthread_equal(pthread_self(), user->thread_id))
-  {
-    sem_wait(&user->user_lock);
-    user->data_vec.erase(user->get_data_it(pthread_self()));
-    sem_post(&user->user_lock);
-    logging->log_this(4, TYPE_INFO, "data thread " + util.itos(thread_id) + " exiting. Remaining data connections for " + user->user_name + " is: " + util.itos(user->data_vec.size()));
-  }
-}
-
-User::User(int socket_id, struct sockaddr_in &addr){
-  sem_init(&user_lock, 0, 1);
-
-  User::ctrl_addr = addr;
-  User::socket_id = socket_id;
-  User::logged_in = NOT_LOGGED_IN;
-  User::thread_id = pthread_self();
-  User::data_id = 0;
-  User::rest_pos = 0;
-  User::host_name = inet_ntoa(User::ctrl_addr.sin_addr);
-  User::root_dir = "/";
-  User::failed_logins = 0;
-  User::total_transfered = 0;
-  this->settings.reset();
+  this->_root_dir = "/";
+  this->_failed_logins = 0;
+  this->_total_transfered = 0;
+  this->_logged_in = NOT_LOGGED_IN;
+  this->_data_id = 0;
+  this->_rest_pos = 0;
+  this->addr(addr);
+  this->socket_id(socket_id);
+  this->thread_id(pthread_self());
+  this->host_name(inet_ntoa(this->addr().sin_addr));
+  struct timeval tmp = {config->general_user.idle, 0};
+  this->timeout(tmp);
 
   // setting the bitflags on mlst_facts... not to clean..
   for(int i = 0; i <= LAST_FACT; i++)
-    this->settings.set(i);
+    this->settings(i, B_SET);
 }
 
-User::~User(){
-  if(socket_id)
-    close(socket_id);
-  if(data_id)
-    close(data_id);
+User::~User()
+{
+  if(this->_data_id)
+    close(this->_data_id);
 
-  if(settings.test(PAM_DONE))
+  if(this->settings(PAM_DONE))
   {
     sem_wait(&comm.pam_lock);
-    pam_close_session(pamh, PAM_SILENT);
-    pam_end(pamh, PAM_SUCCESS);
+    pam_close_session(this->_pamh, PAM_SILENT);
+    pam_end(this->_pamh, PAM_SUCCESS);
     sem_post(&comm.pam_lock);
   }
 
-  sem_destroy(&user_lock);
-
   // killing off any ongoing data threads
-  for(vector<Data*>::iterator data_it = data_vec.begin(); data_it != data_vec.end(); data_it++)
+  for(vector<Data*>::iterator data_it = data_vec.begin();
+      data_it != data_vec.end(); data_it++)
     if(*data_it)
-      pthread_cancel((*data_it)->thread_id);
+      pthread_cancel((*data_it)->thread_id());
 
   while(data_vec.size())
   {  }
 
-#ifdef USE_TLS
-  // TLS cleanup here.
-  if(this->settings.test(TLS_INITED))
-  {
-    gnutls_db_remove_session(this->ctrl_session);
-    gnutls_deinit(this->ctrl_session);
-  }
-#endif
-
   sem_wait(&user_list_lock);
-  user_list.erase(get_user_it(pthread_self()));
+  user_list.erase(get_user_it(this->thread_id()));
   sem_post(&user_list_lock);
-  logging->log_this(3, TYPE_INFO, "user thread " + util.itos(thread_id) + " exiting, connected users:" + util.itos(user_list.size()));
+  logging->log_this(4, TYPE_INFO, "user thread " +
+      util.itos(this->thread_id()) + " exiting, connected users:" +
+      util.itos(user_list.size()));
 }
 
 vector<User*>::iterator get_user_it(pthread_t thread_id)
@@ -181,7 +66,7 @@ vector<User*>::iterator get_user_it(pthr
   vector<User*>::iterator user_it;
   
   for(user_it = user_list.begin(); user_it != user_list.end(); user_it++)
-    if(pthread_equal((*user_it)->thread_id, thread_id))
+    if(pthread_equal((*user_it)->thread_id(), thread_id))
       break;
   
   return(user_it);
@@ -192,8 +77,9 @@ vector<Data*>::iterator User::get_data_i
 {
   vector<Data*>::iterator data_it;
 
-  for(data_it = this->data_vec.begin(); data_it != this->data_vec.end(); data_it++)
-    if(pthread_equal((*data_it)->thread_id, thread_id))
+  for(data_it = this->data_vec.begin(); data_it != this->data_vec.end();
+      data_it++)
+    if(pthread_equal((*data_it)->thread_id(), thread_id))
       break;
   
   return(data_it);
@@ -201,17 +87,62 @@ vector<Data*>::iterator User::get_data_i
 
 bool User::data_vec_full() const
 {
-  if(data_vec.size() >= static_cast<size_t>(config->get_user(user_name).sim_data))
+  if(data_vec.size() >=
+      static_cast<size_t>(config->get_user(this->user_name()).sim_data))
     return(true);
   return(false);
 }
 
-void kill_user(void *user)
+bool User::login(void)
 {
-  delete static_cast<User*>(user);
+  char pwdata[PWBUF_SIZE];
+  struct passwd pwd, *pwd_ptr;
+  this->logged_in(LOGGED_IN);
+  getpwnam_r(this->user_name().c_str(), &pwd, pwdata, sizeof(pwdata),
+      &pwd_ptr);
+  uid_t uid = pwd.pw_uid;
+  gid_t gid = pwd.pw_gid;
+  if(config->get_user(this->user_name()).only_home)
+    this->root_dir(pwd.pw_dir);
+  this->current_dir(pwd.pw_dir);
+  seteuid(0);
+  setgid(gid);
+  seteuid(uid); // dropping permissions...
+  struct timeval tmp = {config->get_user(this->user_name()).idle, 0};
+  this->timeout(tmp);
+  return true;
 }
   
-void kill_data(void *data)
+User &User::operator>>(string &message)
 {
-  delete static_cast<Data*>(data);
+  char tmp_buf[210] = { 0 };
+  fd_set rfd;
+  FD_ZERO(&rfd);
+  FD_SET(this->socket_id(), &rfd);
+  timeval tv = this->timeout();
+
+  if(!select(this->socket_id() + 1, &rfd, NULL, NULL, &tv))
+  {
+    *this << "421 Connection timed out("
+      << util.itos(config->get_user(this->user_name()).idle)
+      << " seconds). Disconnected.";
+    if(this->logged_in())
+      logging->log_this(3, TYPE_AUTH, "User " + this->user_name() +
+          ", disconnected due to timeout.");
+
+    this->settings(FAILURE, B_SET);
+  }
+  else
+  {
+    if(this->receive(tmp_buf, 200) > 0)
+      message = tmp_buf;
+    else
+      this->settings(FAILURE, B_SET);
+  }
+  return *this;
+}
+
+void kill_user(void *user)
+{
+  delete static_cast<User*>(user);
 }
Index: User.h
===================================================================
RCS file: /cvsroot/babyftpd/babyftpd/User.h,v
retrieving revision 1.74
diff -u -p -b -r1.74 User.h
--- User.h	16 Jan 2005 00:55:24 -0000	1.74
+++ User.h	10 Apr 2005 22:43:20 -0000
@@ -1,5 +1,5 @@
 /////////////////////////////////////////////////////////////////////
-// $Id: User.h,v 1.74 2005/01/16 00:55:24 klas Exp $
+// $Id: User.h,v 1.91 2005/04/10 21:57:36 jockelundin Exp $
 //
 // Usage: Holds information about connected users.
 //
@@ -7,122 +7,62 @@
 //    LICENSE for complete information.
 /////////////////////////////////////////////////////////////////////
 
-#ifndef __USER_H__
-#define __USER_H__
+#ifndef USER_H
+#define USER_H
 
-#ifdef __USER_CPP__
+#ifdef USER_CPP
 #include "generic.h"
-#include "Configuration.h"
-#include "Handler.h"
-#include "Commands.h"
 #include "Utilities.h"
+#include "Configuration.h"
 #include "Log.h"
+#include "Connection.h"
+#include "Data.h"
+#include "Commands.h"
 #endif
 
-#define NOT_LOGGED_IN 0
-#define USER_SUPPLIED 1
-#define LOGGED_IN 2
-#define LOGGED_OUT 3
-
-#define FACT_TYPE 0 // for mlsx
-#define FACT_SIZE 1
-#define FACT_MODIFY 2
-#define FACT_UNIQUE 3
-#define FACT_U_MODE 4
-#define FACT_U_UID 5
-#define FACT_U_GID 6
-#define FACT_U_LINK 7
-#define FACT_PERM 8
-#define LAST_FACT 8
-
-#define DATA_ACCT 9
-#define BINARY 10
-#define COMPRESSED 11
-#define PASSIVE 12
-#define ANONYMOUS 13
-#define DATA_OPEN 14
-#define EPSV_ONLY 15
-#define RETR_TRANS 16
-#define PAM_DONE 17
-#ifdef USE_TLS
-#define TLS_ENABLED 18
-#define TLS_INITED 19
-#define TLS_PBSZ 20
-#define TLS_PROT_D 21
-
-// keep an eye on these.. different depending on TLS or not...
-#define TOTAL_U_BIT 22
-#else
-#define TOTAL_U_BIT 18
-#endif // USE_TLS
-
+const int NOT_LOGGED_IN = 0;
+const int USER_SUPPLIED = 1;
+const int LOGGED_IN = 2;
+
+// macro that builds get and set functions for us.
+#define MEMBER(func, type, var)  private: type var; \
+  public: type func(void)const{return var;} \
+  public: void func(type var){ \
+          sem_wait(&this->lock); \
+          this->var = var; \
+          sem_post(&this->lock); \
+        }
 
-class Data
-{
-  private:
-    bool open;
-  public:
-    Data(User *user, int file_id = -1, string file_name = "", int trans_type = 0);
-    ~Data();
-    bool isOpen() const;
-    int data_id;
-    struct sockaddr_in data_addr;
-    int trans_type;
-    int file_id;
-    bitset<TOTAL_U_BIT> settings;
-    off_t rest_pos;
-    sem_t data_lock;
-    pthread_t thread_id;
-    string file_name;
-    string host_name; // NEVER modify this after dns_lookup thread is spawned. never.
-    User *user;
-#ifdef USE_TLS
-    gnutls_session data_session;
-#endif // USE_TLS
-};
-
-class User
+class User : public Connection
 {
+  friend class Data;
   public:
     User(int socket_id, struct sockaddr_in &addr);
     vector<Data*>::iterator get_data_it(pthread_t);
+    User &operator>>(string &message);
     bool data_vec_full() const;
+    bool login();
     ~User();
     vector<Data*> data_vec;
-    string user_name;
-    int logged_in;
-    int socket_id;
-    int data_id;
-    struct sockaddr_in ctrl_addr;
-    struct sockaddr_in data_addr;
-    string host_name; // NEVER modify this after dns_lookup thread is spawned. never.
-    string current_dir;
-    string root_dir;
-    string temp_buf; // is this for anything but rename? shouldn't be the way I just changed it around -kl
-    bitset<TOTAL_U_BIT> settings;
-    int failed_logins;
-    off_t rest_pos;
-    unsigned long long total_transfered; // this variable will hold the total number of transfered bytes.
-    sem_t user_lock;
-    pthread_t thread_id;
-#ifdef USE_TLS
-    gnutls_session ctrl_session;
-#endif // USE_TLS
-    pam_handle_t *pamh;
+    MEMBER(logged_in, int, _logged_in);
+    MEMBER(data_id, int, _data_id);
+    MEMBER(data_addr, struct sockaddr_in, _data_addr);
+    MEMBER(current_dir, string, _current_dir);
+    MEMBER(root_dir, string, _root_dir);
+    MEMBER(temp_buf, string, _temp_buf); // is this for anything but rename?
+    MEMBER(failed_logins, int, _failed_logins);
+    MEMBER(total_transfered, unsigned long long, _total_transfered);
+    MEMBER(pamh, pam_handle_t*, _pamh);
+    MEMBER(rest_pos, off_t, _rest_pos);
 };
 
+#undef MEMBER
+
 vector<User*>::iterator get_user_it(pthread_t);
 void kill_user(void*);
-void kill_data(void*);
 
 extern pthread_key_t my_user;
-extern pthread_key_t my_data;
 extern sem_t user_list_lock;
-extern pthread_t main_thread;
 extern vector<User*> user_list;
-extern class Configuration *config;
-extern class Handler handler;
-extern class Commands comm;
-extern class Utilities util;
 
-#endif
+#endif // USER_H
Index: Utilities.cpp
===================================================================
RCS file: /cvsroot/babyftpd/babyftpd/Utilities.cpp,v
retrieving revision 1.40
diff -u -p -b -r1.40 Utilities.cpp
--- Utilities.cpp	8 Jan 2005 22:42:18 -0000	1.40
+++ Utilities.cpp	10 Apr 2005 22:43:20 -0000
@@ -1,5 +1,5 @@
 /////////////////////////////////////////////////////////////////////
-// $Id: Utilities.cpp,v 1.40 2005/01/08 22:42:18 klas Exp $
+// $Id: Utilities.cpp,v 1.49 2005/04/06 18:06:28 klas Exp $
 //
 // Usage: Various functions that doesn't belong anywhere else.
 //
@@ -7,9 +7,10 @@
 //    LICENSE for complete information.
 /////////////////////////////////////////////////////////////////////
 
-#define __UTILITIES_CPP__
+#define UTILITIES_CPP
 #include "Utilities.h"
 
+class Utilities util;
 
 // function to remove line break at the end of a string
 void Utilities::strip_line_breaks(string &victim)
@@ -36,13 +37,14 @@ int Utilities::clean_string(string &vict
   while(isspace(victim[victim.size() - 1]))
     victim.erase(victim.size() - 1, 1);
   
-  for(string::iterator victim_it = victim.begin(); victim_it != victim.end(); ++victim_it)
+  for(string::iterator victim_it = victim.begin(); victim_it != victim.end();
+      ++victim_it)
   {
-    if(isspace(*victim_it) || iscntrl(*victim_it))
+    if(isspace(*victim_it) || !isascii(*victim_it))
     {
-      if(*victim_it == ' ') // isspace() triggers on more than space...
+      if(*victim_it == ' ')
         spaces++;
-      if((isspace(*(victim_it - 1))) || iscntrl(*victim_it))
+      if((isspace(*(victim_it - 1))) || !isascii(*victim_it))
       {
         if(*victim_it == ' ')
           spaces--;
@@ -55,12 +57,12 @@ int Utilities::clean_string(string &vict
 }
 
 // function to convert an int to a string
-string Utilities::itos(int num)
+string Utilities::itos(long long int num)
 {
   string message;
-  char buf[12];
+  char buf[12] = {0};
   
-  snprintf(buf, 12, "%d", num);
+  snprintf(buf, 12, "%lld", num);
   message = buf;
   
   return(message);
@@ -86,26 +88,26 @@ string Utilities::parse_perms_ls(mode_t 
   else if(S_ISSOCK(perm))
     attr[0] = 's';
 
-  if(test(perm, S_IRUSR)) attr[1] = 'r';
-  if(test(perm, S_IWUSR)) attr[2] = 'w';
-  if(test(perm, S_IXUSR)) {
-    if(test(perm, S_ISUID)) attr[3] = 's';
+  if(is_set(perm, S_IRUSR)) attr[1] = 'r';
+  if(is_set(perm, S_IWUSR)) attr[2] = 'w';
+  if(is_set(perm, S_IXUSR)) {
+    if(is_set(perm, S_ISUID)) attr[3] = 's';
     else attr[3] = 'x';
-  } else if(test(perm, S_ISUID)) attr[3] = 'S';
+  } else if(is_set(perm, S_ISUID)) attr[3] = 'S';
   
-  if(test(perm, S_IRGRP)) attr[4] = 'r';
-  if(test(perm, S_IWGRP)) attr[5] = 'w';
-  if(test(perm, S_IXGRP)) {
-    if(test(perm, S_ISGID)) attr[6] = 's';
+  if(is_set(perm, S_IRGRP)) attr[4] = 'r';
+  if(is_set(perm, S_IWGRP)) attr[5] = 'w';
+  if(is_set(perm, S_IXGRP)) {
+    if(is_set(perm, S_ISGID)) attr[6] = 's';
     else attr[6] = 'x';
-  } else if(test(perm, S_ISGID)) attr[6] = 'S';
+  } else if(is_set(perm, S_ISGID)) attr[6] = 'S';
   
-  if(test(perm, S_IROTH)) attr[7] = 'r';
-  if(test(perm, S_IWOTH)) attr[8] = 'w';
-  if(test(perm, S_IXOTH)) {
-    if(test(perm, S_ISVTX)) attr[9] = 't';
+  if(is_set(perm, S_IROTH)) attr[7] = 'r';
+  if(is_set(perm, S_IWOTH)) attr[8] = 'w';
+  if(is_set(perm, S_IXOTH)) {
+    if(is_set(perm, S_ISVTX)) attr[9] = 't';
     else attr[9] = 'x';
-  } else if(test(perm, S_ISVTX)) attr[9] = 'T';
+  } else if(is_set(perm, S_ISVTX)) attr[9] = 'T';
 
   return(attr);
 }
@@ -116,32 +118,50 @@ string Utilities::parse_perms_num(mode_t
 
   attr = "0000";
   
-  if(test(perm, S_ISUID))
+  if(is_set(perm, S_ISUID))
     attr[0] += 4;
-  if(test(perm, S_ISGID))
+  if(is_set(perm, S_ISGID))
     attr[0] += 2;
-  if(test(perm, S_ISVTX))
+  if(is_set(perm, S_ISVTX))
     attr[0]++;
-  if(test(perm, S_IRUSR))
+  if(is_set(perm, S_IRUSR))
     attr[1] += 4;
-  if(test(perm, S_IWUSR))
+  if(is_set(perm, S_IWUSR))
     attr[1] += 2;
-  if(test(perm, S_IXUSR))
+  if(is_set(perm, S_IXUSR))
     attr[1]++;
 
-  if(test(perm, S_IRGRP))
+  if(is_set(perm, S_IRGRP))
     attr[2] += 4;    
-  if(test(perm, S_IWGRP)) 
+  if(is_set(perm, S_IWGRP))
     attr[2] += 2;    
-  if(test(perm, S_IXGRP))
+  if(is_set(perm, S_IXGRP))
     attr[2]++;
 
-  if(test(perm, S_IROTH))
+  if(is_set(perm, S_IROTH))
     attr[3] += 4;
-  if(test(perm, S_IWOTH))
+  if(is_set(perm, S_IWOTH))
     attr[3] += 2;
-  if(test(perm, S_IXOTH))
+  if(is_set(perm, S_IXOTH))
     attr[3]++;
 
   return(attr);
 }
+
+
+int Utilities::time_string(string &victim, string format,
+    size_t len, time_t timep)
+{
+  char *timestr = new char[len + 1];
+  struct tm now;
+  memset(timestr, 0, len + 1);
+
+  if(timep == 0)
+    timep = time(NULL);
+  localtime_r(&timep, &now);
+  int ret = strftime(timestr, len, format.c_str(), &now);
+  victim = timestr;
+
+  delete[] timestr;
+  return(ret);
+}
